/*
 * Copyright (c) 2013-2024 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * Refreshes the Calendars tab in the scheduler view panel.
 */
Ext.define( 'QDesk.controller.command.scheduler.quartz.calendar.RefreshCalendarsTab', {
  extend : 'QDesk.controller.command.BaseCommand',

  requires : [
    'QDesk.Msg',

    'QDesk.controller.command.scheduler.quartz.calendar.RefreshCalendarsGrid'
  ],

  /**
   * Required {@link QDesk.ConnectionContext} instance.
   */
  connectionCtx : undefined,


  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.connectionCtx )
      Ext.Error.raise( 'Required config parameter missing: connectionCtx' );

    me.callParent( [ config ] );
  },


  execute : function ()
  {
    var me = this;

    // refreshes the scheduler audit trail grid
    Ext.create( 'QDesk.controller.command.scheduler.quartz.calendar.RefreshCalendarsGrid', {
      connectionCtx : me.connectionCtx,
      success : function ()
      {
      },
      failure : function ()
      {
      }
    } ).execute();
  }
} );
