/*
 * Copyright (c) 2013-2024 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 * The calendar data model.
 */
Ext.define( 'QDesk.model.scheduler.quartz.QuartzCalendar', {
  extend : 'Ext.data.Model',
  fields : [
    /* QuartzCalendar attributes */
    { name : 'type', type : 'string' }, // QDesk.model.scheduler.quartz.QuartzCalendarType

    { name : 'name', type : 'string' },
    { name : 'description', type : 'string', allowNull : true },
    { name : 'baseCalendarName', type : 'string', allowNull : true },

    /* QuartzAnnualCalendar */
    { name : 'yearday', type : 'auto' }, // list of QDesk.model.common.Yearday

    /* QuartzCronTrigger */
    { name : 'cronExpression', type : 'string', allowNull : true },

    /* QuartzDailyCalendar */
    { name : 'timeRangeFrom', type : 'auto', allowNull : true }, // QDesk.model.common.DayTime
    { name : 'timeRangeTo', type : 'auto', allowNull : true }, // QDesk.model.common.DayTime
    { name : 'invertTimeRange', type : 'boolean', allowNull : true },

    /* QuartzHolidayCalendar */
    { name : 'date', type : 'auto' }, // list of QDesk.model.common.Date

    /* QuartzMonthlyCalendar */
    { name : 'day', type : 'auto' }, // list of int

    /* QuartzWeeklyCalendar */
    { name : 'weekday', type : 'auto' }, // list of QDesk.model.common.WeekDay

    /*
     * QuartzAnnualCalendar, QuartzCronTrigger, QuartzDailyCalendar, QuartzHolidayCalendar,
     * QuartzMonthlyCalendar, QuartzWeeklyCalendar
     */
    { name : 'timeZone', reference : 'TimeZone', allowNull: true }
  ]
} );
