/*
 * Copyright (c) 2013-2024 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel', {
  extend : 'Ext.panel.Panel',

  requires : [
    'QDesk.Msg',
    'QDesk.Properties',

    'QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity',

    'QDesk.util.EnumUtils'
  ],

  alias : 'widget.IncidentMgmtFreshserviceBasicPanel',

  border : false,

  layout : 'anchor',

  defaults : {
    anchor : '100%',
    labelWidth : 100
  },

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    Ext.apply( config, {
      title : QDesk.Msg.get(
          'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.tabLabelBasic' ),

      items : [
        {
          xtype : 'textfield',
          itemId : 'endpointUrl',
          name : 'endpointUrl',
          fieldLabel : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldLabelEndpointUrl' ),
          fieldTooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldTooltipEndpointUrl' ),
          emptyText : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldEmptyTxtEndpointUrl' ),
          allowBlank : false,
          maxLength : 128,
          vtype : 'url',
          qdesk : {
            required : true
          }
        },

        {
          xtype : 'textfield',
          itemId : 'authKey',
          name : 'authKey',
          fieldLabel : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldLabelAuthKey' ),
          fieldTooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldTooltipAuthKey' ),
          emptyText : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldEmptyTxtAuthKey' ),
          allowBlank : false,
          maxLength : 192,
          qdesk : {
            required : true
          }
        },

        // alert properties
        {
          xtype : 'fieldset',
          title : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldsetLabelAlertProperties' ),
          tooltip : QDesk.Msg.get(
              'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldsetTooltipAlertProperties' ),
          padding : '5 5 0 5',
          defaults : {
            anchor : '100%',
            labelWidth : 95
          },
          items : [
            {
              xtype : 'textfield',
              itemId : 'source',
              name : 'source',
              fieldLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldLabelSource' ),
              fieldTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldTooltipSource' ),
              emptyText : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldEmptyTxtSource' ),
              allowBlank : false,
              maxLength : 100,
              qdesk : {
                required : true
              }
            },

            {
              xtype : 'combo',
              itemId : 'severity',
              name : 'severity',
              fieldLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldLabelSeverity' ),
              fieldTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldTooltipSeverity' ),
              emptyText : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldEmptyTxtSeverity' ),
              anchor : '60%',
              value : '',
              editable : false,
              forceSelection : true,
              queryMode : 'local',
              store : new Ext.data.ArrayStore( {
                fields : [
                  'value',
                  'valueLabel'
                ],
                data : [
                  [ QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.OK,
                    QDesk.util.EnumUtils.getFreshserviceSeverityName(
                        QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.OK ) ],
                  [ QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.WARNING,
                    QDesk.util.EnumUtils.getFreshserviceSeverityName(
                        QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.WARNING ) ],
                  [ QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.ERROR,
                    QDesk.util.EnumUtils.getFreshserviceSeverityName(
                        QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.ERROR ) ],
                  [ QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.CRITICAL,
                    QDesk.util.EnumUtils.getFreshserviceSeverityName(
                        QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.CRITICAL ) ]
                ]
              } ),
              valueField : 'value',
              displayField : 'valueLabel',
              allowBlank : false,
              maxLength : 10,
              qdesk : {
                required : true
              }
            },

            {
              xtype : 'tagfield',
              itemId : 'tag',
              name : 'tag',
              fieldLabel : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldLabelTag' ),
              fieldTooltip : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldTooltipTag' ),
              emptyText : QDesk.Msg.get(
                  'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldEmptyTxtTag' ),
              store : new Ext.data.ArrayStore( {
                fields : [
                  'value'
                ],
                data : []
              } ),
              displayField : 'value',
              valueField : 'value',
              createNewOnEnter : true,
              createNewOnBlur : true,
              forceSelection : false,
              queryMode : 'local',
              expand : Ext.emptyFn,
              hideTrigger : true,
              grow : true,
              growMax : 110,

              allowBlank : true,
              validator : function ( v )
              {
                var valueArray = this.getValue();
                if ( !Ext.isEmpty( valueArray ) )
                {
                  // check the number of tags in the list
                  if ( valueArray.length > 5 )
                  {
                    return QDesk.Msg.get(
                        'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldValidationMaxTagCountExceededTag' );
                  }

                  // check the length of individual tags
                  var maxTagLengthExceeded = false;
                  Ext.each( valueArray, function ( value )
                  {
                    if ( value.length > 50 )
                    {
                      maxTagLengthExceeded = true;
                      return false;
                    }
                  } );

                  if ( maxTagLengthExceeded )
                  {
                    return QDesk.Msg.get(
                        'QDesk.view.work.message.channel.incident_mgmt.freshservice.FreshserviceBasicPanel.fieldValidationMaxTagLengthExceededAction' );
                  }
                }
                return true;
              },
              qdesk : {
                required : false
              }
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );
  },


  initComponent : function ()
  {
    var me = this;

    me.callParent();

    // set default alert severity
    var severityCombo = me.down( '#severity' );
    severityCombo.setValue( QDesk.model.message.channel.incident_mgmt.FreshserviceSeverity.OK );
  }
} );
